﻿using UnityEngine;
using System.Collections;

public class Controller2D : MonoBehaviour {

	//Reference to my Character Controller
	CharacterController characterController;

	//Controls gravity
	public float gravity = 10.0f;

	public float walkSpeed = 5.0f;
	public float jumpHeight = 5.0f;

	//Show that we take damage
	float takeDamage = 0.2f;

	//Controlling our Players Movement Direction
	Vector3 moveDirection = Vector3.zero;
	float horizontal = 0;

	//Player Attack
	public Rigidbody bulletPrefab;
	bool lookRight = true;
	float attackRate = 0.5f;
	float cooldown;

	// Use this for initialization
	void Start () {
		characterController = GetComponent<CharacterController> ();
	}
	
	// Update is called once per frame
	void Update () {
		//Control Character Controller
		characterController.Move (moveDirection * Time.deltaTime);
		horizontal = Input.GetAxis ("Horizontal");

		//Controls Player Gravity
		moveDirection.y -= gravity * Time.deltaTime;

		if(horizontal == 0)
			moveDirection.x = horizontal;

		//move the player to the right
		if (horizontal > 0.01)
		{
			lookRight = true;
			moveDirection.x = horizontal * walkSpeed;
		}
		// move the player to the left
		if (horizontal < -0.01)
		{
			lookRight = false;
			moveDirection.x = horizontal * walkSpeed;
		}

		// Jump Controls
		if (characterController.isGrounded) 
		{
			if(Input.GetButton("Jump"))
			{
				moveDirection.y = jumpHeight;
			}
		}

		// Attack Control
		if (Input.GetKeyDown (KeyCode.F))
			BulletAttack ();
	}

	public IEnumerator TakeDamage()
	{
			renderer.enabled = false;
			yield return new WaitForSeconds (takeDamage);
			renderer.enabled = true;
			yield return new WaitForSeconds (takeDamage);
			renderer.enabled = false;
			yield return new WaitForSeconds (takeDamage);
			renderer.enabled = true;
			yield return new WaitForSeconds (takeDamage);
			renderer.enabled = false;
			yield return new WaitForSeconds (takeDamage);
			renderer.enabled = true;
	}

	public void Swipe(Vector2 force)
	{
		transform.rigidbody2D.AddForce (force);
	}

	void BulletAttack()
	{	
		if (Time.time >= cooldown) 
		{
			Rigidbody bPrefab = Instantiate (bulletPrefab, transform.position, Quaternion.identity) as Rigidbody;
			cooldown = Time.time + .5f;
		
			if(lookRight)
				bPrefab.rigidbody.AddForce (Vector3.right * 500);
			if(!lookRight)
				bPrefab.rigidbody.AddForce (-Vector3.right * 500);
		}
	}	
}
